﻿using System;
using System.Web;
using System.Web.Mvc;
using Demo1.Models;
using Mindscape.LightSpeed;

namespace Demo1.Controllers
{
  public class TaskController : BaseController
  {
    [ControllerAction]
    public void Index()
    {
      RenderView("Index");
    }

    [ControllerAction]
    public void New()
    {
      TaskViewData tvd = new TaskViewData();
      tvd.AllPeople = Repository.Find<Person>();
      tvd.AllProjects = Repository.Find<Project>();

      RenderView("New", tvd);
    }

    [ControllerAction]
    public void Create(string subject, string notes, Guid projectId, Guid personId)
    {
      Task task = new Task();
      task.Subject = subject;
      task.Notes = notes;
      task.PersonId = personId;
      task.ProjectId = projectId;

      Repository.Add(task);
      Repository.CompleteUnitOfWork();

      RedirectToAction("Index");
    }

    [ControllerAction]
    public void Detail(string id)
    {
      TaskViewData viewData = new TaskViewData();

      viewData.Task = Repository.FindOne<Task>(id);

      RenderView("Detail", viewData);
    }
  }
}
