using System;

using Mindscape.LightSpeed;

namespace Demo1.Models
{
  [Serializable]
  public partial class Task : Entity<Guid>
  {
    #region Fields
  
    private Guid _projectId;
    private Guid _personId;
    private string _subject;
    private string _notes;

    #endregion
    
    #region Relationships

    private readonly EntityHolder<Person> _person = new EntityHolder<Person>();
    private readonly EntityHolder<Project> _project = new EntityHolder<Project>();

    #endregion
    
    #region Properties

    public Person AssignedTo
    {
      get { return Get(_person); }
    }

    public Project Project
    {
      get { return Get(_project); }
    }

    public Guid ProjectId
    {
      get { return _projectId; }
      set { SetValue(ref _projectId, value); }
    }

    public Guid PersonId
    {
      get { return _personId; }
      set { SetValue(ref _personId, value); }
    }

    public string Subject
    {
      get { return _subject; }
      set { SetValue(ref _subject, value); }
    }

    public string Notes
    {
      get { return _notes; }
      set { SetValue(ref _notes, value); }
    }

    #endregion
  }
}
