﻿using NUnit.Framework;
using System.Transactions;
using Mindscape.LightSpeed;
using Demo1.Models;

namespace Tests
{
  [TestFixture]
  public class ModelTests
  {
    private TransactionScope _transactionScope;

    [SetUp]
    public void SetUp()
    {
      // Setup LightSpeed manually
      LightSpeedContext.ConnectionString = @"Server=.\SQLEXPRESS; Database=TaskTracker;Integrated Security=SSPI;";
      LightSpeedContext.DataProvider = DataProvider.SqlServer2005;
      LightSpeedContext.IdentityMethod = IdentityMethod.Guid;

      _transactionScope = new TransactionScope();
    }

    [TearDown]
    public void TearDown()
    {
      Repository.CompleteUnitOfWork(false);

      _transactionScope.Dispose();
    }

    [Test]
    public void PersonTest()
    {
      Person person = new Person();
      person.Name = "Andrew";
      person.EmailAddress = "andrew@mindscape.co.nz";

      Repository.Add(person);
      Repository.SaveChanges(true);

      Person theNewPerson = Repository.FindOne<Person>(person.Id);

      Assert.AreNotSame(person, theNewPerson);
      Assert.AreEqual("Andrew", theNewPerson.Name);
    }
  }
}
